/* 
 * Hason.java
 * file-ok :SorOlvas-val trtn sszehasonlt rutinjai
 * by pts@fazekas.hu at Fri Mar 30 21:02:36 CEST 2001
 * tovbbi doksi: a README-ben s e file legkls class-nak fejkommentjben
 *
 * Kincskeres Kisgmbc (C) Early May 2001 by eNTitnok (Rv Szilvia,
 * Szab Pter <pts@inf.bme.hu>, Szurdi Mikls, Weizengruber Attila).
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or   
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the  
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package eNTitanok.util;
import java.io.FileInputStream;
import java.io.IOException;
// import eNTitanok.util.SorOlvaso;

/**
 * File-ok :SorOlvas-val trtn sszehasonlt rutinjai.
 * @see eNTitanok.util.SorOlvaso
 */
public class Hason {
  /**
   * A megadott kt file-t :SorOlvas-val olvasva hasonltja ssze
   * @return pontosan akkor igaz, ha megegyeznek
   * @see eNTitanok.util.SorOlvaso
   * @see eNTitanok.util.Hason#hasonlit_mester
   * @see eNTitanok.util.Hason#hasonlit_prefix
   */
  public static boolean hasonlit(String nev1, String nev2) throws IOException {
    // Imp: sorszm/karakterpozci visszadsa
    SorOlvaso s1=new SorOlvaso(new FileInputStream(nev1));
    SorOlvaso s2=new SorOlvaso(new FileInputStream(nev2));
    String sor1, sor2;
    while (true) {
      sor1=s1.readLine(); sor2=s2.readLine();
      if (sor1==null && sor2==null) { s1.close(); s2.close(); return true; }
      if (sor1==null || sor2==null) { s1.close(); s2.close(); return false; }
      if (!sor1.equals(sor2))       { s1.close(); s2.close(); return false; }
    }
  }
  /**
   * A megadott kt file-t :SorOlvas-val olvasva hasonltja ssze, de az els
   * file-nak csak a prefix-szel kezdd sorait veszi figyelembe, levgva
   * bellk prefix-et.
   * @return pontosan akkor igaz, ha a file-ok megegyeznek
   * @see eNTitanok.util.SorOlvaso
   * @see eNTitanok.util.Hason#hasonlit
   */
  public static boolean hasonlit_prefix(String nev1, String nev2, String prefix) throws IOException {
    // Imp: sorszm/karakterpozci visszadsa
    SorOlvaso s1=new SorOlvaso(new FileInputStream(nev1));
    SorOlvaso s2=new SorOlvaso(new FileInputStream(nev2));
    String sor1, sor2;
    while (true) {
      while (true) {
        sor1=s1.readLine();
        if (sor1==null || sor1.startsWith(prefix)) break;
      }
      sor1=sor1.substring(prefix.length());
      sor2=s2.readLine();
      if (sor1==null && sor2==null) { s1.close(); s2.close(); return true; }
      if (sor1==null || sor2==null) { s1.close(); s2.close(); return false; }
      if (!sor1.equals(sor2))       { s1.close(); s2.close(); return false; }
    }
  }
  /**
   * A megadott file <TT>fn_prefix</TT>-szel kezdd sorbl veszi a msik
   * file nevt, amivel a megadott file <TT>sor_prefix</TT>-szel kezdd sorait
   * :SorOlvas-val olvasva hasonltja ssze. fn_prefix egyszer szerepelhet,
   * mgpedig az els sor_prefix eltt.
   * @return pontosan akkor igaz, ha a file-ok megegyeznek
   * @see eNTitanok.util.SorOlvaso
   * @see eNTitanok.util.Hason#hasonlit
   * @see eNTitanok.util.Hason#hasonlit_prefix
   */
  public static boolean hasonlit_mester(String nev1, String fn_prefix, String sor_prefix) throws IOException {
    // Imp: sorszm/karakterpozci visszadsa
    SorOlvaso s1=new SorOlvaso(new FileInputStream(nev1));
    String sor1, sor2;
    while ((sor1=s1.readLine())!=null && !sor1.startsWith(fn_prefix));
    // System.out.println(sor1);
    if (null==sor1) return false; // Imp: tbbfle visszatrsi kd
    SorOlvaso s2=new SorOlvaso(new FileInputStream(sor1.substring(fn_prefix.length())));
    while (true) {
      while (true) {
        sor1=s1.readLine();
        if (sor1==null || sor1.startsWith(sor_prefix)) break;
      }
      if (sor1!=null) sor1=sor1.substring(sor_prefix.length());
      sor2=s2.readLine();
      // System.out.println("ZZZ"); // DEBUG
      // System.out.println(sor1); // DEBUG
      // System.out.println(sor2); // DEBUG
      if (sor1==null && sor2==null) { s1.close(); s2.close(); return true; }
      if (sor1==null || sor2==null) { s1.close(); s2.close(); return false; }
      if (!sor1.equals(sor2))       { s1.close(); s2.close(); return false; }
    } /// WHILE
  } /// hasonlit_mester()
} /// class Hason
